<?php
class ControllerModuleFeaturedCategory extends Controller {
	protected function index($setting) {
		$this->language->load('module/featuredcategory'); 

      	$this->data['heading_title'] = $this->language->get('heading_title');
		
		$this->load->model('catalog/category'); 
		
		$this->load->model('tool/image');

		$this->data['category'] = array();

		$categories = explode(',', $this->config->get('featured_category'));		

		if (empty($setting['limit'])) {
			$setting['limit'] = 5;
		}
		
		$categories = array_slice($categories, 0, (int)$setting['limit']);
		
		
		
		
		foreach ($categories as $category_id) {
			$category_info = $this->model_catalog_category->getCategory($category_id);
			
			if ($category_info) {
				if ($category_info['image']) {
					$image = $this->model_tool_image->resize($category_info['image'], $setting['image_width'], $setting['image_height']);
				} else {
					$image = false;
				}

					
				$this->data['categories'][] = array(
					'category_id' => $category_info['category_id'],
					'thumb'   	 => $image,
					'name' => utf8_substr(strip_tags(html_entity_decode($category_info['name'], ENT_QUOTES, 'UTF-8')), 0, 15),
					'description' => utf8_substr(strip_tags(html_entity_decode($category_info['description'], ENT_QUOTES, 'UTF-8')), 0, 70) . '..',
					'href'    	 => $this->url->link('product/category', 'path=' . $category_info['category_id']),
				);
			}
		}


		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/module/featuredcategory.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/module/featuredcategory.tpl';
		} else {
			$this->template = 'default/template/module/featuredcategory.tpl';
		}

		$this->render();
	}
}
?>